#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_DaySigninCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_DaySigninCFG> M_DaySigninCFG::msSingleton(nullptr);

int M_DaySigninCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_DaySigninCFGData* M_DaySigninCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_DaySigninCFGData>& M_DaySigninCFG::GetMapData()
{
	return mMapData;
}

void M_DaySigninCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_DaySigninCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_DaySigninCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		data.mReceive = element->IntAttribute("Receive");
		data.mShowResource = element->Attribute("ShowResource");
		data.mValue = element->IntAttribute("Value");
		data.mType = element->IntAttribute("Type");
		data.mParameter = element->IntAttribute("Parameter");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_DaySigninCFG::Load()
{
	Load("../Config/M_DaySigninCFG.xml");
}

M_DaySigninCFG* M_DaySigninCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_DaySigninCFG());
	}
	return msSingleton.get();
}
